! ---------------------------------------------------
!   Solve for the roots of  Ax^2 + Bx + C = 0 
! ---------------------------------------------------

PROGRAM  quadroots
   IMPLICIT  NONE

   REAL  :: a, b, c
   REAL  :: d
   REAL  :: q1, q2

!  read in the coefficients a, b and c

   READ(*,*)  a, b, c
   WRITE(*,*) 'a = ', a
   WRITE(*,*) 'b = ', b
   WRITE(*,*) 'c = ', c
   WRITE(*,*)

!  compute the square root of discriminant d

   d = b*b - 4.0*a*c
   IF (d >= 0.0) THEN              ! is it solvable?
      d     = SQRT(d)
      q1 = (-b + d)/(2.0*a)     ! first root
      q2 = (-b - d)/(2.0*a)     ! second root
      WRITE(*,*)  'Roots are ', q1, ' and ', q2
   ELSE                            ! complex roots
      WRITE(*,*)  'The roots are complex'
   END IF

END PROGRAM  quadroots
